## giada 0.20.0%2Bds1

=== CMakeLists.txt ===
# ------------------------------------------------------------------------------
# Preliminary setup
# ------------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.12)

# CMAKE_OSX_DEPLOYMENT_TARGET should be set prior to the first project() or
# enable_language() command invocation because it may influence configuration
# of the toolchain and flags.
# Also, see https://stackoverflow.com/questions/34208360/cmake-seems-to-ignore-cmake-osx-deployment-target

if(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	set(CMAKE_OSX_DEPLOYMENT_TARGET "10.14" CACHE STRING "Minimum OS X deployment version")
endif()

# ------------------------------------------------------------------------------
# Project
# ------------------------------------------------------------------------------

project(giada LANGUAGES CXX)

# ------------------------------------------------------------------------------
# Lists definition
#
# SOURCES - contains the source files
# PREPROCESSOR_DEFS - preprocessor definitions
# INCLUDE_DIRS - include directories (e.g. -I)
# COMPILER_OPTIONS - additional flags for the compiler
# LIBRARIES - external dependencies to link
# COMPILER_FEATURES - e.g. C++17
# TARGET_PROPERTIES - additional properties for the target 'giada'.
# ------------------------------------------------------------------------------

list(APPEND SOURCES
	src/main.cpp
	src/core/engine.cpp
	src/core/worker.cpp
	src/core/eventDispatcher.cpp
	src/core/midiDispatcher.cpp
	src/core/midiMapper.cpp
	src/core/midiEvent.cpp
	src/core/quantizer.cpp
	src/core/conf.cpp
	src/core/kernelAudio.cpp
	src/core/jackTransport.cpp
	src/core/mixerHandler.cpp
	src/core/sequencer.cpp
	src/core/metronome.cpp
	src/core/init.cpp
	src/core/wave.cpp
	src/core/waveFx.cpp
	src/core/kernelMidi.cpp
	src/core/graphics.cpp
	src/core/patch.cpp
	src/core/actions/actionRecorder.cpp
	src/core/actions/actions.cpp
	src/core/mixer.cpp
    src/core/synchronizer.cpp
	src/core/waveManager.cpp
    src/core/recorder.cpp
	src/core/midiLearnParam.cpp
	src/core/resampler.cpp
	src/core/plugins/pluginHost.cpp
	src/core/plugins/pluginManager.cpp
	src/core/plugins/plugin.cpp
	src/core/plugins/pluginState.cpp
	src/core/channels/sampleActionRecorder.cpp
	src/core/channels/midiActionRecorder.cpp
	src/core/channels/waveReader.cpp
	src/core/channels/midiController.cpp
	src/core/channels/sampleReactor.cpp
	src/core/channels/sampleAdvancer.cpp
	src/core/channels/samplePlayer.cpp
	src/core/channels/audioReceiver.cpp
	src/core/channels/midiLighter.cpp
	src/core/channels/midiLearner.cpp
	src/core/channels/midiSender.cpp
	src/core/channels/midiReceiver.cpp
	src/core/channels/channel.cpp
	src/core/channels/channelManager.cpp
	src/core/model/sequencer.cpp
	src/core/model/mixer.cpp
	src/core/model/recorder.cpp
	src/core/model/model.cpp
	src/core/model/storage.cpp
	src/core/idManager.cpp
	src/glue/events.cpp
	src/glue/main.cpp
	src/glue/io.cpp
	src/glue/storage.cpp
	src/glue/channel.cpp
	src/glue/plugin.cpp
	src/glue/recorder.cpp
	src/glue/sampleEditor.cpp
	src/glue/actionEditor.cpp
	src/glue/config.cpp
	src/glue/layout.cpp
	src/gui/ui.cpp
	src/gui/dialogs/window.cpp
	src/gui/dispatcher.cpp
	src/gui/updater.cpp
	src/gui/drawing.cpp
	src/gui/dialogs/progress.cpp
	src/gui/dialogs/keyGrabber.cpp
	src/gui/dialogs/about.cpp
	src/gui/dialogs/mainWindow.cpp
	src/gui/dialogs/beatsInput.cpp
	src/gui/dialogs/warnings.cpp
	src/gui/dialogs/bpmInput.cpp
	src/gui/dialogs/channelNameInput.cpp
	src/gui/dialogs/config.cpp
	src/gui/dialogs/pluginList.cpp
	src/gui/dialogs/pluginWindow.cpp
	src/gui/dialogs/sampleEditor.cpp
	src/gui/dialogs/pluginWindowGUI.cpp
	src/gui/dialogs/pluginChooser.cpp
	src/gui/dialogs/actionEditor/baseActionEditor.cpp
	src/gui/dialogs/actionEditor/sampleActionEditor.cpp
	src/gui/dialogs/actionEditor/midiActionEditor.cpp
	src/gui/dialogs/browser/browserBase.cpp
	src/gui/dialogs/browser/browserDir.cpp
	src/gui/dialogs/browser/browserLoad.cpp
	src/gui/dialogs/browser/browserSave.cpp
	src/gui/dialogs/midiIO/midiOutputBase.cpp
	src/gui/dialogs/midiIO/midiOutputSampleCh.cpp
	src/gui/dialogs/midiIO/midiOutputMidiCh.cpp
	src/gui/dialogs/midiIO/midiInputBase.cpp
	src/gui/dialogs/midiIO/midiInputChannel.cpp
	src/gui/dialogs/midiIO/midiInputMaster.cpp
	src/gui/elems/midiIO/midiLearner.cpp
	src/gui/elems/midiIO/midiLearnerPack.cpp
	src/gui/elems/browser.cpp
	src/gui/elems/soundMeter.cpp
	src/gui/elems/plugin/pluginBrowser.cpp
	src/gui/elems/plugin/pluginParameter.cpp
	src/gui/elems/plugin/pluginElement.cpp
	src/gui/elems/sampleEditor/waveform.cpp
	src/gui/elems/sampleEditor/waveTools.cpp
	src/gui/elems/sampleEditor/volumeTool.cpp
	src/gui/elems/sampleEditor/boostTool.cpp
	src/gui/elems/sampleEditor/panTool.cpp
	src/gui/elems/sampleEditor/pitchTool.cpp
	src/gui/elems/sampleEditor/rangeTool.cpp
	src/gui/elems/sampleEditor/shiftTool.cpp
	src/gui/elems/actionEditor/baseActionEditor.cpp
	src/gui/elems/actionEditor/baseAction.cpp
	src/gui/elems/actionEditor/envelopeEditor.cpp
	src/gui/elems/actionEditor/velocityEditor.cpp
	src/gui/elems/actionEditor/envelopePoint.cpp
	src/gui/elems/actionEditor/pianoRoll.cpp
	src/gui/elems/actionEditor/pianoItem.cpp
	src/gui/elems/actionEditor/sampleActionEditor.cpp
	src/gui/elems/actionEditor/sampleAction.cpp
	src/gui/elems/actionEditor/gridTool.cpp
	src/gui/elems/actionEditor/splitScroll.cpp
	src/gui/elems/mainWindow/mainIO.cpp
	src/gui/elems/mainWindow/mainMenu.cpp
	src/gui/elems/mainWindow/mainTimer.cpp
	src/gui/elems/mainWindow/mainTransport.cpp
	src/gui/elems/mainWindow/sequencer.cpp
	src/gui/elems/mainWindow/keyboard/channelMode.cpp
	src/gui/elems/mainWindow/keyboard/channelButton.cpp
	src/gui/elems/mainWindow/keyboard/channelStatus.cpp
	src/gui/elems/mainWindow/keyboard/keyboard.cpp
	src/gui/elems/mainWindow/keyboard/column.cpp
	src/gui/elems/mainWindow/keyboard/sampleChannel.cpp
	src/gui/elems/mainWindow/keyboard/midiChannel.cpp
	src/gui/elems/mainWindow/keyboard/channel.cpp
	src/gui/elems/mainWindow/keyboard/sampleChannelButton.cpp
	src/gui/elems/mainWindow/keyboard/midiChannelButton.cpp
	src/gui/elems/config/tabMisc.cpp
	src/gui/elems/config/tabMidi.cpp
	src/gui/elems/config/tabAudio.cpp
	src/gui/elems/config/tabBehaviors.cpp
	src/gui/elems/config/tabPlugins.cpp
	src/gui/elems/basics/scroll.cpp
	src/gui/elems/basics/pack.cpp
	src/gui/elems/basics/group.cpp
	src/gui/elems/basics/scrollPack.cpp
	src/gui/elems/basics/boxtypes.cpp
	src/gui/elems/basics/statusButton.cpp
	src/gui/elems/basics/button.cpp
	src/gui/elems/basics/resizerBar.cpp
	src/gui/elems/basics/input.cpp
	src/gui/elems/basics/liquidScroll.cpp
	src/gui/elems/basics/choice.cpp
	src/gui/elems/basics/dial.cpp
	src/gui/elems/basics/box.cpp
	src/gui/elems/basics/slider.cpp
	src/gui/elems/basics/progress.cpp
	src/gui/elems/basics/check.cpp
	src/gui/elems/basics/split.cpp
	src/utils/log.cpp
	src/utils/time.cpp
	src/utils/math.cpp
	src/utils/gui.cpp
	src/utils/fs.cpp
	src/utils/ver.cpp
	src/utils/string.cpp
	src/deps/rtaudio/RtAudio.cpp
	src/deps/mcl-audio-buffer/src/audioBuffer.cpp)

list(APPEND PREPROCESSOR_DEFS)
list(APPEND INCLUDE_DIRS
	${CMAKE_SOURCE_DIR}
	${CMAKE_SOURCE_DIR}/src)
list(APPEND COMPILER_OPTIONS)
list(APPEND LIBRARIES)
list(APPEND COMPILER_FEATURES cxx_std_17)
list(APPEND TARGET_PROPERTIES)

# ------------------------------------------------------------------------------
# Detect OS
# ------------------------------------------------------------------------------

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
	set(OS_LINUX 1)
elseif(CMAKE_SYSTEM_NAME STREQUAL "Windows")
	set(OS_WINDOWS 1)
elseif(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	set(OS_MACOS 1)
elseif(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
	set(OS_FREEBSD 1)
else()
	message(FATAL_ERROR "Unsupported platform '${CMAKE_SYSTEM_NAME}', quitting.")
endif()

# ------------------------------------------------------------------------------
# Compiler warnings
# ------------------------------------------------------------------------------

if(DEFINED OS_WINDOWS)
	list(APPEND COMPILER_OPTIONS /W4 /bigobj /external:anglebrackets /external:W0)
else()
	list(APPEND COMPILER_OPTIONS -Wall -Wextra -Wpedantic)
endif()

# ------------------------------------------------------------------------------
# Options
# ------------------------------------------------------------------------------

option(WITH_VST2 "Enable VST2 support." OFF)
option(WITH_VST3 "Enable VST3 support." OFF)
option(WITH_TESTS "Include the test suite." OFF)

if(DEFINED OS_LINUX)
	option(WITH_ALSA "Enable ALSA support (Linux only)." ON)
	option(WITH_PULSE "Enable PulseAudio support (Linux only)." ON)
	option(WITH_JACK "Enable JACK support (Linux only)." ON)
endif()

if(WITH_TESTS)
	list(APPEND PREPROCESSOR_DEFS 
		WITH_TESTS
		TEST_RESOURCES_DIR="${CMAKE_SOURCE_DIR}/tests/resources/")
endif()

if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
	list(APPEND PREPROCESSOR_DEFS NDEBUG)
endif()

# ------------------------------------------------------------------------------
# Dependencies
# ------------------------------------------------------------------------------

# Threads (system)

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
list(APPEND LIBRARIES Threads::Threads)

# pkg-config/pkgconf, required to find some external dependencies on some
# platforms
find_package(PkgConfig)

# RtMidi

find_package(RtMidi CONFIG)
if (RtMidi_FOUND)
	list(APPEND LIBRARIES RtMidi::rtmidi)
	message("RtMidi library found in " ${RtMidi_DIR})
elseif (PkgConfig_FOUND)
	pkg_check_modules(RtMidi IMPORTED_TARGET rtmidi)
	if (RtMidi_FOUND)
		list(APPEND LIBRARIES PkgConfig::RtMidi)
		message("RtMidi library found")
	endif()
endif()

if (NOT RtMidi_FOUND)
	# Fallback to find_library mode (in case rtmidi is too old). 
	find_library(LIBRARY_RTMIDI NAMES rtmidi)
	list(APPEND LIBRARIES ${LIBRARY_RTMIDI})

	if (NOT LIBRARY_RTMIDI)
		message(FATAL_ERROR "Can't find RtMidi, aborting.")
	endif()

	# RtMidi header path may vary across OSes, so a fix is needed.
	# TODO - Find a way to avoid this additional step

	find_path(LIBRARY_RTMIDI_INCLUDE_DIR RtMidi.h PATH_SUFFIXES rtmidi)
	list(APPEND INCLUDE_DIRS ${LIBRARY_RTMIDI_INCLUDE_DIR})
	message("RtMidi library found in " ${RtMidi_DIR})
endif()

# FLTK 

set(FLTK_SKIP_FLUID TRUE)  # Don't search for FLTK's fluid
set(FLTK_SKIP_OPENGL TRUE) # Don't search for FLTK's OpenGL
find_package(FLTK REQUIRED NO_MODULE)
list(APPEND LIBRARIES fltk)
list(APPEND INCLUDE_DIRS ${FLTK_INCLUDE_DIRS})
message("FLTK library found in " ${FLTK_DIR})

# Libsndfile

find_package(SndFile CONFIG)
if (SndFile_FOUND)
	list(APPEND LIBRARIES SndFile::sndfile)
	message("Libsndfile library found in " ${SndFile_DIR})
elseif(PkgConfig_FOUND)
	pkg_check_modules(SndFile IMPORTED_TARGET sndfile)
	if (SndFile_FOUND)
		list(APPEND LIBRARIES PkgConfig::SndFile)
		message("Libsndfile library found")
	endif()	
endif()

if (NOT SndFile_FOUND)
	# Fallback to find_library mode (in case libsndfile is too old). 
	find_library(LIBRARY_SNDFILE NAMES sndfile libsndfile libsndfile-1)
	
	if (NOT LIBRARY_SNDFILE)
		message(FATAL_ERROR "Can't find libsndfile, aborting.")
	endif()

	list(APPEND LIBRARIES ${LIBRARY_SNDFILE})
	message("Libsndfile library found in " ${LIBRARY_SNDFILE})

	# Find optional dependencies.

	find_library(LIBRARY_FLAC NAMES flac FLAC)
	find_library(LIBRARY_OGG NAMES ogg)
	find_library(LIBRARY_OPUS NAMES opus libopus)
	find_library(LIBRARY_VORBIS NAMES vorbis)
	find_library(LIBRARY_VORBISENC NAMES vorbisenc)

	if(LIBRARY_FLAC)
		list(APPEND LIBRARIES ${LIBRARY_FLAC})
	endif()
	if(LIBRARY_OGG)
		list(APPEND LIBRARIES ${LIBRARY_OGG})
	endif()
	if(LIBRARY_OPUS)
		list(APPEND LIBRARIES ${LIBRARY_OPUS})
	endif()
	if(LIBRARY_VORBIS)
		list(APPEND LIBRARIES ${LIBRARY_VORBIS})
	endif()
	if(LIBRARY_VORBISENC)
		list(APPEND LIBRARIES ${LIBRARY_VORBISENC})
	endif()	
endif()

# Libsamplerate

find_package(SampleRate CONFIG)
if (SampleRate_FOUND)
	list(APPEND LIBRARIES SampleRate::samplerate)

## giada 0.7.0

=== debian/changelog ===
giada (0.7.0-0~precise1) precise; urgency=low

  * New upstream release

 -- falkTX <falktx@gmail.com>  Fri, 21 Jun 2013 22:02:05 +0100

giada (0.6.2-0~precise1) precise; urgency=low

  * New upstream release

 -- falkTX <falktx@gmail.com>  Fri, 05 Apr 2013 12:02:23 +0100

giada (0.5.7-0~precise2) precise; urgency=low

  * Add libsamplerate-dev to build depends

 -- falkTX <falktx@gmail.com>  Tue, 05 Feb 2013 13:48:41 +0000

giada (0.5.7-0~precise1) precise; urgency=low

  * New usptream release

 -- falkTX <falktx@gmail.com>  Tue, 05 Feb 2013 13:43:35 +0000

giada (0.5.5-0~precise1) precise; urgency=low

  * New upstream release, refresh patches

 -- falkTX <falktx@gmail.com>  Tue, 18 Dec 2012 08:46:47 +0000

giada (0.5.3-0~precise4) precise; urgency=low

  * Initial release

 -- falkTX <falktx@gmail.com>  Tue, 15 May 2012 01:49:53 +0100

=== debian/control ===
Source: giada
Section: sound
Priority: extra
Maintainer: falkTX <falktx@gmail.com>
Build-Depends: debhelper (>= 7), dh-autoreconf,
  libfltk1.3-dev, librtaudio-dev, libsndfile1-dev, libsamplerate-dev,
  libxpm-dev, libxft-dev, libxext-dev
Standards-Version: 3.8.4

Package: giada
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: audio tool for djs and live performers
 Giada is a free, minimal, hardcore audio tool for djs and live performers.
 Load or record up to 32 samples, choose to play them in single mode
 (drum machine) or loop mode (sequencer) and start the show with your
 computer keyboard as a controller.

=== debian/rules ===
#!/usr/bin/make -f

LDFLAGS+=-Wl,--as-needed

override_dh_auto_configure:
	dh_auto_configure -- --target=linux # --enable-vst

%:
	dh $@ --with autoreconf

## giada 0.9.6~dfsg1

=== debian/changelog ===
giada (0.9.6~dfsg1-2) unstable; urgency=medium

  * Attempt to fix build on arm64 and ppc64el.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 18 Jun 2015 09:58:19 +0200

giada (0.9.6~dfsg1-1) unstable; urgency=medium

  * Initial release. (Closes: Bug#786610)

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Wed, 08 Apr 2015 14:59:44 +0200

=== debian/control ===
Source: giada
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Jaromír Mikeš <mira.mikes@seznam.cz>,
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>
Build-Depends:
 debhelper (>= 9),
 dh-autoreconf,
 autotools-dev,
 libsndfile1-dev (>= 1.0.25),
 libsamplerate0-dev (>= 0.1.8),
 libasound2 (>= 1.0.16),
 libjack-dev,
 libpulse-dev,
 libxft2-dev,
 libxpm-dev,
 libxext-dev,
 libfltk1.3-dev,
 librtmidi-dev (>= 2.1.0~ds0)
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/giada.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/giada.git
Homepage: http://www.giadamusic.com

Package: giada
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 jackd
Description: Hardcore Loop Machine
 free, minimal, hardcore audio tool for DJs,
 live performers and electronic musicians.
 Pick up your channel, fill it with samples or MIDI events
 and start the show by using this tiny piece of software
 as a loop machine, drum machine, sequencer,
 live sampler or yet as a plugin/effect host.
 .
 Giada aims to be a compact and portable virtual device
 for production use and live sets.

## giada 0.10.0~dfsg1

=== debian/changelog ===
giada (0.10.0~dfsg1-1build1) wily; urgency=medium

  * No-change rebuild against libjack-jackd2-0v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 11 Aug 2015 06:40:52 +0000

giada (0.10.0~dfsg1-1) unstable; urgency=medium

  * Imported Upstream version 0.10.0~dfsg1
  * Patches refreshed.
  * Added spelling patch.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 07 Jul 2015 14:40:16 +0200

giada (0.9.6~dfsg1-3) unstable; urgency=medium

  * Fixed FTBFS due to parenthesization (Closes: #791544)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 07 Jul 2015 11:20:10 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: giada
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders:
  Jaromír Mikeš <mira.mikes@seznam.cz>,
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>

## giada 0.10.2~dfsg1

=== debian/changelog ===
giada (0.10.2~dfsg1-2) unstable; urgency=medium

  * unit-tests
    * Made tests failing more verbosely
    * Set ${HOME} to /tmp
  * debian/README.source
    * Documented git-tuneclone.sh
    * Fixed typos

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 23 Nov 2015 00:15:05 +0100

giada (0.10.2~dfsg1-1) unstable; urgency=medium

  [ Jaromír Mikeš ]
  * Imported Upstream version 0.10.2~dfsg1

  [ IOhannes m zmölnig ]
  * Enable C++11 to prevent FTBFS in tests
  * Made build reproducible
    * Patch to allow setting of DATE in about-dialog
    * Set BUILD_DATE to date from debian/changelog
  * Removed giada.menu
    (in response to the tech-ctte decision on #741573)
  * Updated debian/copyright
  * Updated Vcs-Browser stanza
  * Added debian/git-tuneclone.sh script

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 06 Nov 2015 22:28:02 +0100

giada (0.10.1~dfsg1-1) unstable; urgency=medium

  * Imported Upstream version 0.10.1~dfsg1
  * Remove patch - apllied upstream.
  * Refresh patch.
  * Upstream build changed - tune rules file accordingly.
  * Update copyright file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 03 Sep 2015 03:43:59 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: giada
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders:
  Jaromír Mikeš <mira.mikes@seznam.cz>,
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>
@@ -22,7 +21,7 @@
  librtmidi-dev (>= 2.1.0~ds0)
 Standards-Version: 3.9.6
 Vcs-Git: git://anonscm.debian.org/pkg-multimedia/giada.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/giada.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/giada.git
 Homepage: http://www.giadamusic.com
 
 Package: giada

=== debian/rules ===
#!/usr/bin/make -f

# Path to the debian directory
DEBIAN_DIR := $(shell echo ${MAKEFILE_LIST} | awk '{print $$1}' | xargs dirname )
UPSTREAM_VERSION ?=$(shell uscan --dehs | sed -n 's/.*<upstream-version>\(.*\)<\/upstream-version>.*/\1/p')
DFSG = dfsg1
PKG = $(shell dpkg-parsechangelog | sed -ne 's/^Source: //p')
DATE := $(shell date -u -d "$$(dpkg-parsechangelog -SDate)" +"%Y/%m/%d")

CPPFLAGS+=-DBUILD_DATE='"$(DATE)"'
CXXFLAGS+=-std=c++11
LDFLAGS+=-Wl,--as-needed

%:
	dh $@ --parallel --with autoreconf,autotools-dev

override_dh_autoreconf:
	./autogen.sh
	dh_autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --target=linux

override_dh_auto_test:
	@echo home: $(HOME)
	HOME=/tmp dh_auto_test -a || (grep . test-suite.log giada_test.log; false)
	#make check      || (grep . test-suite.log giada_test.log; false)

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=.
	tar -xf $(PKG)_$(UPSTREAM_VERSION).orig.tar.gz
	mv $(PKG)-$(UPSTREAM_VERSION) $(PKG)-$(UPSTREAM_VERSION)~$(DFSG)
	rm -rf $(PKG)-$(UPSTREAM_VERSION)~$(DFSG)/src/rtaudio-mod/include
	rm -rf $(PKG)-$(UPSTREAM_VERSION)~$(DFSG)/src/vst
	rm -rf $(PKG)-$(UPSTREAM_VERSION)~$(DFSG)/src/*.dll
	rm -rf $(PKG)-$(UPSTREAM_VERSION)~$(DFSG)/.gitignore
	XZ_OPT=-9 tar cJf ../$(PKG)_$(UPSTREAM_VERSION)~$(DFSG).orig.tar.xz $(PKG)-$(UPSTREAM_VERSION)~$(DFSG)
	rm -rf $(PKG)-$(UPSTREAM_VERSION)~$(DFSG)
	rm -rf $(PKG)_$(UPSTREAM_VERSION).orig.tar.gz

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/giada-$1\.tar\.gz/,uversionmangle=s/-rc/~rc/,dversionmangle=s/~dfsg.*// \
  https://github.com/monocasual/giada/tags .*/v?(\d\S*)\.tar\.gz

## giada 0.11.2~dfsg

=== debian/changelog ===
giada (0.11.2~dfsg-1) unstable; urgency=medium

  * Imported Upstream version 0.11.2~dfsg

  * File-Exclude bundled libraries
    * Explain repacking in detail
    * Simplified get-orig-source rule
    * Added repack-suffix to debian/watch
  * Refreshed patches
  * Skip tests that require missing files
  * Clean up in rtaudio-mod directory
  * Use https:// in Vcs-Git stanza
  * Bumped standards to 3.9.7

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 16 Feb 2016 15:39:16 +0100

giada (0.11.0~dfsg1-1) unstable; urgency=medium

  * Imported Upstream version 0.11.0~dfsg1
  * Patch applied upstream.
  * Add libjansson-dev as build dep.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Wed, 02 Dec 2015 09:45:41 +0100

=== debian/control ===
--- 
+++ 
@@ -18,9 +18,10 @@
  libxpm-dev,
  libxext-dev,
  libfltk1.3-dev,
- librtmidi-dev (>= 2.1.0~ds0)
-Standards-Version: 3.9.6
-Vcs-Git: git://anonscm.debian.org/pkg-multimedia/giada.git
+ librtmidi-dev (>= 2.1.0~ds0),
+ libjansson-dev
+Standards-Version: 3.9.7
+Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/giada.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/giada.git
 Homepage: http://www.giadamusic.com

=== debian/rules ===
#!/usr/bin/make -f

# Path to the debian directory
DEBIAN_DIR := $(shell echo ${MAKEFILE_LIST} | awk '{print $$1}' | xargs dirname )
UPSTREAM_VERSION ?=$(shell uscan --dehs | sed -n 's/.*<upstream-version>\(.*\)<\/upstream-version>.*/\1/p')
PKG = $(shell dpkg-parsechangelog | sed -ne 's/^Source: //p')
DATE := $(shell date -u -d "$$(dpkg-parsechangelog -SDate)" +"%Y/%m/%d")

CPPFLAGS+=-DBUILD_DATE='"$(DATE)"'
CXXFLAGS+=-std=c++11
LDFLAGS+=-Wl,--as-needed

%:
	dh $@ --parallel --with autoreconf,autotools-dev

override_dh_autoreconf:
	./autogen.sh
	dh_autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --target=linux

override_dh_auto_test:
	@echo home: $(HOME)
	HOME=/tmp dh_auto_test -a || (grep . test-suite.log giada_test.log; false)
	#make check      || (grep . test-suite.log giada_test.log; false)

override_dh_auto_clean:
	dh_auto_clean
	test -e src/deps/rtaudio-mode/Makefile && make -C src/deps/rtaudio-mod/ distclean || true

## all the file-exclusion magic is handled by debian/copyright
get-orig-source:
	uscan  --download

## giada 0.12.1~dfsg1

=== debian/changelog ===
giada (0.12.1~dfsg1-1) unstable; urgency=medium

  * Imported Upstream version 0.12.1~dfsg1
    * Dropped embedded copy of non-free ASIO SDK in rtaudio-mod
      that had accidentally crept in with 0.11.0 (Closes: #823318)
  * Dropped patches applied upstream.
  * Dropped references to JUCE
  * Bumped to standards version 3.9.8

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 17 May 2016 15:54:31 +0200

## giada 0.12.2~dfsg1

=== debian/changelog ===
giada (0.12.2~dfsg1-2) unstable; urgency=medium

  * Add patch to build with new rtmidi lib. (Closes: #828955)
    Thanks to James Cowgill <jcowgill@debian.org> 

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 04 Jul 2016 16:03:13 +0200

giada (0.12.2~dfsg1-1) unstable; urgency=medium

  * Imported Upstream version 0.12.2~dfsg1
  * Patch refreshed.
  * Update copyright file.
  * Fix hardening.
  * Add overrides file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Wed, 22 Jun 2016 14:41:40 +0200

=== debian/control ===
--- 
+++ 
@@ -20,7 +20,7 @@
  libfltk1.3-dev,
  librtmidi-dev (>= 2.1.0~ds0),
  libjansson-dev
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/giada.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/giada.git
 Homepage: http://www.giadamusic.com

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,8 @@
 UPSTREAM_VERSION ?=$(shell uscan --dehs | sed -n 's/.*<upstream-version>\(.*\)<\/upstream-version>.*/\1/p')
 PKG = $(shell dpkg-parsechangelog | sed -ne 's/^Source: //p')
 DATE := $(shell date -u -d "$$(dpkg-parsechangelog -SDate)" +"%Y/%m/%d")
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 CPPFLAGS+=-DBUILD_DATE='"$(DATE)"'
 CXXFLAGS+=-std=c++11

## giada 0.13.2~dfsg1

=== debian/changelog ===
giada (0.13.2~dfsg1-1) unstable; urgency=medium

  * Remove more files on repack.
  * New upstream version 0.13.2~dfsg1
  * Patches deleted/refreshed.
  * Clean up rules file.
  * Remove B-D dh_autoreconf.
  * Update copyright file.
  * Sign tags.
  * Install only svg icon.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sun, 15 Jan 2017 18:51:32 +0100

giada (0.13.1~dfsg1-1) unstable; urgency=medium

  * New upstream version 0.13.1~dfsg1
  * Patch refreshed.
  * Set dh/compat 10.
  * Add patch to fix FTBFS.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 21 Nov 2016 09:32:55 +0100

giada (0.13.0~dfsg1-1) unstable; urgency=medium

  * New upstream version 0.13.0~dfsg1
  * Refresh patch.
  * Drop patches applied upstream.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Fri, 02 Sep 2016 01:35:02 +0200

giada (0.12.2~dfsg1-3) unstable; urgency=medium

  * Add patch to build with gcc6 (Closes: ##831183).
  * Numbering patches.
  * Tune .gitignore file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 25 Jul 2016 01:09:36 +0200

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,7 @@
  Jaromír Mikeš <mira.mikes@seznam.cz>,
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>
 Build-Depends:
- debhelper (>= 9),
- dh-autoreconf,
+ debhelper (>= 10),
  autotools-dev,
  libsndfile1-dev (>= 1.0.25),
  libsamplerate0-dev (>= 0.1.8),

=== debian/rules ===
#!/usr/bin/make -f

DATE := $(shell date -u -d "$$(dpkg-parsechangelog -SDate)" +"%Y/%m/%d")

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CPPFLAGS+=-DBUILD_DATE='"$(DATE)"'
CXXFLAGS+=-std=c++11

%:
	dh $@

override_dh_autoreconf:
	./autogen.sh
	dh_autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --target=linux

override_dh_auto_test:
	@echo home: $(HOME)
	HOME=/tmp dh_auto_test -a || (grep . test-suite.log giada_test.log; false)

override_dh_auto_clean:
	dh_auto_clean
	test -e src/deps/rtaudio-mode/Makefile && make -C src/deps/rtaudio-mod/ distclean || true

## all the file-exclusion magic is handled by debian/copyright
get-orig-source:
	uscan  --download

=== debian/watch ===
version=3
opts=repacksuffix=~dfsg1,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/giada-$1\.tar\.gz/,uversionmangle=s/-rc/~rc/,dversionmangle=s/~dfsg.*// \
  https://github.com/monocasual/giada/tags .*/v?(\d\S*)\.tar\.gz

## giada 0.14.1~dfsg1

=== debian/changelog ===
giada (0.14.1~dfsg1-1) unstable; urgency=medium

  * New upstream version 0.14.1~dfsg1
  * Patch refreshed.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 24 Jul 2017 01:10:36 +0200

giada (0.14.0~dfsg1-1) unstable; urgency=medium

  * New upstream version 0.14.0~dfsg1
  * Patch forwarded.
  * Bump Standards.
  * Add catch as B-D.
  * Add patch to test with system-wide catch.
  * Update copyright file.
  * Remove not-needed override file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 26 Jun 2017 11:43:49 +0200

=== debian/control ===
--- 
+++ 
@@ -18,8 +18,9 @@
  libxext-dev,
  libfltk1.3-dev,
  librtmidi-dev (>= 2.1.0~ds0),
- libjansson-dev
-Standards-Version: 3.9.8
+ libjansson-dev,
+ catch
+Standards-Version: 4.0.0
 Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/giada.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/giada.git
 Homepage: http://www.giadamusic.com

## giada 0.14.3~dfsg1

=== debian/changelog ===
giada (0.14.3~dfsg1-1build1) bionic; urgency=medium

  * No-change rebuild against librtmidi4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 05 Nov 2017 06:44:49 +0000

giada (0.14.3~dfsg1-1) unstable; urgency=medium

  * New upstream version 0.14.3~dfsg1

  [ Jaromír Mikeš ]
  * Introduce postclone.sh script to ignore .pc/ dir.
  * Patches refreshed.

  [ IOhannes m zmölnig ]
  * Updated patches
    * Updated patch headers for use with gbp-pq
    * Refreshed patches
    * Updated bundled RtAudio to RtAudio5
    * Added patch to fix compilation with g++-7 (Closes: #853418)
    * Added missing files to catch-patch
  * Dropped unneeded B-D on autotools-dev
  * Dropped override_dh_autoconf
  * Calculated BUILD_DATE based on SOURCE_DATE_EPOCH
  * Switched to https:// where possible
  * Fixed typo in d/README.source
  * Bumped standards version to 4.1.1

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 30 Oct 2017 10:08:45 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: giada
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders:
  Jaromír Mikeš <mira.mikes@seznam.cz>,
- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>
+ IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Build-Depends:
  debhelper (>= 10),
- autotools-dev,
  libsndfile1-dev (>= 1.0.25),
  libsamplerate0-dev (>= 0.1.8),
  libasound2 (>= 1.0.16),
@@ -19,19 +19,19 @@
  libfltk1.3-dev,
  librtmidi-dev (>= 2.1.0~ds0),
  libjansson-dev,
- catch
-Standards-Version: 4.0.0
+ catch,
+Standards-Version: 4.1.1
 Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/giada.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/giada.git
-Homepage: http://www.giadamusic.com
+Homepage: https://www.giadamusic.com
 
 Package: giada
 Architecture: any
 Depends:
  ${shlibs:Depends},
- ${misc:Depends}
+ ${misc:Depends},
 Recommends:
- jackd
+ jackd,
 Description: Hardcore Loop Machine
  free, minimal, hardcore audio tool for DJs,
  live performers and electronic musicians.

=== debian/rules ===
--- 
+++ 
@@ -1,20 +1,21 @@
 #!/usr/bin/make -f
-
-DATE := $(shell date -u -d "$$(dpkg-parsechangelog -SDate)" +"%Y/%m/%d")
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
-CPPFLAGS+=-DBUILD_DATE='"$(DATE)"'
+DATE_FMT = %Y-%m-%d
+ifdef SOURCE_DATE_EPOCH
+    BUILD_DATE ?= $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)"  2>/dev/null || date -u -r "$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)" 2>/dev/null || date -u "+$(DATE_FMT)")
+else
+    BUILD_DATE ?= $(shell date "+$(DATE_FMT)")
+endif
+
+CPPFLAGS+=-DBUILD_DATE='"$(BUILD_DATE)"'
 CXXFLAGS+=-std=c++11
 
 %:
 	dh $@
-
-override_dh_autoreconf:
-	./autogen.sh
-	dh_autoreconf
 
 override_dh_auto_configure:
 	dh_auto_configure -- --target=linux

## giada 0.14.5~dfsg1

=== debian/changelog ===
giada (0.14.5~dfsg1-2) unstable; urgency=medium

  * Add patch to fix build on some archs.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Wed, 17 Jan 2018 18:45:49 +0100

giada (0.14.5~dfsg1-1) unstable; urgency=medium

  * New upstream version 0.14.5~dfsg1
  * Patches removed/updated.
  * Set dh/compat 11.
  * Bump Standards.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 16 Jan 2018 23:19:27 +0100

giada (0.14.4~dfsg1-1) unstable; urgency=medium

  * New upstream version 0.14.4~dfsg1
  * Patch refreshed.
  * Vcs - use git instead of cgit.
  * Remove trailing-whitespaces.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sat, 25 Nov 2017 16:35:14 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: giada
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders:
  Jaromír Mikeš <mira.mikes@seznam.cz>,
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Build-Depends:
- debhelper (>= 10),
+ debhelper (>= 11),
  libsndfile1-dev (>= 1.0.25),
  libsamplerate0-dev (>= 0.1.8),
  libasound2 (>= 1.0.16),
@@ -20,9 +19,9 @@
  librtmidi-dev (>= 2.1.0~ds0),
  libjansson-dev,
  catch,
-Standards-Version: 4.1.1
+Standards-Version: 4.1.3
 Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/giada.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/giada.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-multimedia/giada.git
 Homepage: https://www.giadamusic.com
 
 Package: giada

## giada 0.15.1+ds1

=== debian/changelog ===
giada (0.15.1+ds1-1) unstable; urgency=medium

  * New upstream version 0.15.1+ds1

  [ Olivier Humbert ]
  * debian/control :
    - Build-Depends: alphabetical order + one package per line
    - long description (lines were too short)
  * debian/copyright :
    - adding myself
  * debian/giada.desktop :
    - removes [es] name (no need since it's not translated)
    - adds Comment for EN and ES (then they get displayed when mouseovering the
      menu item)
    - adds French Generic Name and Comment
  * debian/giada.1 :
    - suppresses a duplicate (.TH)
  * debian/giada.fr.1 :
    - adds a French manpage (translated from the English one)
  * debian/giada.manpages :
    - install the French manpage

  [ IOhannes m zmölnig ]
  * Refreshed patches
  * Switched to +ds suffix (more widespread than +repack)
  * debian/control :
    - Set Rules-Requires-Root to no
    - Bumped standards version to 4.1.5

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 04 Jul 2018 22:23:58 +0200

giada (0.15.0+repack1-2) unstable; urgency=medium

  * Dropped versioned depends on alsa/sndfile/samplerate
  * Added libatomic to riscv64 builds
  * Install updstream changelog

  * Upload to unstable.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 24 May 2018 10:20:47 +0200

giada (0.15.0+repack1-2~exp2) experimental; urgency=medium

  * Pass "-latomic" via the LIBS

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 23 May 2018 19:56:50 +0200

giada (0.15.0+repack1-2~exp1) experimental; urgency=medium

  * Link against libatomic (on platforms that require it)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 23 May 2018 16:36:00 +0200

giada (0.15.0+repack1-1) unstable; urgency=medium

  * New upstream version 0.15.0+repack1

  * Enabled VST support
    * Build with JUCE
  * Repacked sources
    * Exclude all travis-ci related stuff
    * Don't exclude VST files (dropped upstream)
    * Updated d/watch to new repacksuffix "+repack"
  * Bumped standards version to 4.1.4

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 22 May 2018 21:10:08 +0200

giada (0.14.6~dfsg1-1) unstable; urgency=medium

  * New upstream version 0.14.6~dfsg1

  [ Jaromír Mikeš ]
  * Patch forwarded.

  [ Ondřej Nový ]
  * d/control: Set Vcs-* to salsa.debian.org

  [ IOhannes m zmölnig ]
  * Refreshed patches
  * Run unit-tests in fake-X environment
  * Updated maintainer email

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 04 Apr 2018 21:39:36 +0200

=== debian/control ===
Source: giada
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Jaromír Mikeš <mira.mikes@seznam.cz>,
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 debhelper (>= 11),
 catch,
 juce-modules-source,
 libasound2,
 libfltk1.3-dev,
 libjack-dev,
 libjansson-dev,
 libpulse-dev,
 librtmidi-dev (>= 2.1.0~ds0),
 libsamplerate0-dev,
 libsndfile1-dev,
 libxext-dev,
 libxft2-dev,
 libxpm-dev,
 xauth,
 xvfb,
Standards-Version: 4.1.5
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/multimedia-team/giada.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/giada
Homepage: https://www.giadamusic.com

Package: giada
Architecture: any
Built-Using: ${juce:BuiltUsing},
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Recommends:
 jackd,
Description: Hardcore Loop Machine
 free, minimal, hardcore audio tool for DJs, live performers and electronic
 musicians. Pick up your channel, fill it with samples or MIDI events and start
 the show by using this tiny piece of software as a loop machine, drum machine,
 sequencer, live sampler or yet as a plugin/effect host.
 .
 Giada aims to be a compact and portable virtual device for production use and
 live sets.

## giada 0.15.2+ds1

=== debian/changelog ===
giada (0.15.2+ds1-2) unstable; urgency=medium

  * B-D and link against libcurl (Closes: #923898)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 06 Mar 2019 23:08:53 +0100

giada (0.15.2+ds1-1) unstable; urgency=medium

  * New upstream version 0.15.2+ds1
    * Refreshed patches
  * Bumped standards version to 4.2.1

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sat, 08 Sep 2018 18:22:39 +0200

=== debian/control ===
--- 
+++ 
@@ -11,6 +11,7 @@
  juce-modules-source,
  libasound2,
  libfltk1.3-dev,
+ libcurl4-gnutls-dev | libcurl-dev,
  libjack-dev,
  libjansson-dev,
  libpulse-dev,
@@ -22,7 +23,7 @@
  libxpm-dev,
  xauth,
  xvfb,
-Standards-Version: 4.1.5
+Standards-Version: 4.2.1
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/multimedia-team/giada.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/giada

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DATE_FMT = %Y-%m-%d
ifdef SOURCE_DATE_EPOCH
    BUILD_DATE ?= $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)"  2>/dev/null || date -u -r "$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)" 2>/dev/null || date -u "+$(DATE_FMT)")
else
    BUILD_DATE ?= $(shell date "+$(DATE_FMT)")
endif

JUCE_VERSION := $(shell dpkg-query --show --showformat='$${source:Version}' juce-modules-source)

CPPFLAGS+=-DBUILD_DATE='"$(BUILD_DATE)"'
CXXFLAGS+=-std=c++11 -Wno-error
LIBS=$(shell pkg-config --libs libjpeg libpng libcurl)

# JUCE (used by giada) uses some c++11 features requiring atomic_store_8 and
# atomic_load_8, so we need to link with libatomic on
# armel, powerpc, powerpcspe, m68k, mips, mipsel, sh4, ...
# see also:
# - https://gcc.gnu.org/wiki/Atomic
# - https://gcc.gnu.org/wiki/Atomic/GCCMM/LIbrary
# - the 'clasp' packaging
noatomicarch = $(shell dpkg-architecture -qDEB_HOST_ARCH | egrep -x "(armel|powerpc|powerpcspe|m68k|mips|mipsel|sh4|riscv64)")
# link with libatomic on architectures without built-in atomic
ifeq ($(if $(noatomicarch),atomic), atomic)
	LIBS += -latomic
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		--enable-vst \
		--enable-system-catch \
		--target=linux \
		LIBS="$(LIBS)"

override_dh_auto_build:
	cp -rav /usr/share/juce src/deps/
	dh_auto_build
override_dh_auto_test:
	@echo home: $(HOME)
	HOME=/tmp xvfb-run -a dh_auto_test -a || (grep . test-suite.log giada_test.log; false)

override_dh_auto_clean:
	dh_auto_clean
	test -e src/deps/rtaudio-mode/Makefile && make -C src/deps/rtaudio-mod/ distclean || true

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_gencontrol:
	dh_gencontrol -- \
                -Vjuce:BuiltUsing="juce ( = $(JUCE_VERSION) )"

## all the file-exclusion magic is handled by debian/copyright
get-orig-source:
	uscan  --download

## giada 0.15.4%2Bds1

=== debian/changelog ===
giada (0.15.4+ds1-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:42:15 +0100

giada (0.15.4+ds1-1) unstable; urgency=medium

  * New upstream version 0.15.4+ds1

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat

  [ IOhannes m zmölnig ]
  * B-D on juce>=5.4.4 (Closes: #925695)
  * d/patches
    * Refresh patches
    * Refresh patches with 'gbp pq'
    * Add patch for JUCE-5.4.4 compatibility
  * Build requires C++14
  * Dropped unrecognized 'IX' macro from manpages
  * Drop obsolete d/source/local-options
  * Bump dh compat to 12
  * Bump standards version to 4.4.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 20 Aug 2019 15:32:54 +0200

## giada 0.15.4+ds1

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,9 @@
  Jaromír Mikeš <mira.mikes@seznam.cz>,
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
 Build-Depends:
- debhelper (>= 11),
+ debhelper-compat (= 12),
  catch,
- juce-modules-source,
+ juce-modules-source (>= 5.4.4~),
  libasound2,
  libfltk1.3-dev,
  libcurl4-gnutls-dev | libcurl-dev,
@@ -23,7 +23,7 @@
  libxpm-dev,
  xauth,
  xvfb,
-Standards-Version: 4.2.1
+Standards-Version: 4.4.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/multimedia-team/giada.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/giada

## giada 0.16.2.2%2Bds1

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
 JUCE_VERSION := $(shell dpkg-query --show --showformat='$${source:Version}' juce-modules-source)
 
 CPPFLAGS+=-DBUILD_DATE='"$(BUILD_DATE)"'
-CXXFLAGS+=-std=c++11 -Wno-error
+CXXFLAGS+=-std=c++14 -Wno-error
 LIBS=$(shell pkg-config --libs libjpeg libpng libcurl)
 
 # JUCE (used by giada) uses some c++11 features requiring atomic_store_8 and

## giada 0.16.2.2+ds1

=== debian/changelog ===
giada (0.16.2.2+ds1-1) unstable; urgency=medium

  * New upstream version 0.16.2.2+ds1

  * Refresh patches
    * Refresh RtMidi patch
    * Dropped RtAudio patch
    * Refresh JUCE patch
  * Build against system-provided nlohmann-json3 library
    * Provide a patch for that as well
  * Fix spelling errors
  * Add salsa-ci configuration
  * Refresh d/copyright
  * Bump standards version to 4.5.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 02 Apr 2020 15:19:12 +0200

=== debian/control ===
--- 
+++ 
@@ -21,9 +21,10 @@
  libxext-dev,
  libxft2-dev,
  libxpm-dev,
+ nlohmann-json3-dev,
  xauth,
  xvfb,
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/multimedia-team/giada.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/giada

=== debian/watch ===
version=3
opts=repacksuffix=+ds1,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/giada-$1\.tar\.gz/,uversionmangle=s/-rc/~rc/,dversionmangle=s/\+ds.*// \
  https://github.com/monocasual/giada/tags .*/v?(\d\S*)\.tar\.gz

## giada 0.19.1+ds1

=== debian/changelog ===
giada (0.19.1+ds1-1) unstable; urgency=medium

  * Upload to unstable.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 23 Dec 2021 12:58:30 +0100

giada (0.19.1+ds1-1~exp1) experimental; urgency=medium

  * New upstream version 0.19.1+ds1

  [ IOhannes m zmölnig ]
  * Update patches
    + Drop obsolete patches
    + Refresh patches
  * Add patch for geompp library
  * Add patch to allow compilation with RtAudio-5.2
  * Add patch to fix underlinking against libjpeg and libpng
  * Modernize build with CMake
  * B-D on fst-dev
    + Apply some hacks for FST bugs
  * Versioned B-D on juce
  * Add missing upstream sources
  * Update d/copyright
  * Bump standards version to 4.6.0

  [ Olivier Humbert ]
  * Update README.source
  * d/install: use the upstream icon
  * d/giada.desktop: use the upstream icon
  * Delete giada.svg (we use the upstream logo now)
  * d/copyright: update year for me
  * d/install: typo fix

  [ Dennis Braun ]
  * Update rtmidi patch
  * d/control:
    + Bump dh-compat to 13
    + Add me as uploader
  * d/copyright:
    + Update Files-Excluded
    + Update copyright year
    + Add me to the d/ section
  * d/rules:
    + Update CXXFLAGS
    + Remove -Wl,--as-needed flags
    + Remove get-orig-source
  * d/copyright: Remove .travis* from Files-Excluded

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 23 Dec 2021 09:48:37 +0100

=== debian/control ===
--- 
+++ 
@@ -5,17 +5,19 @@
 Uploaders:
  Jaromír Mikeš <mira.mikes@seznam.cz>,
  IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
+ Dennis Braun <d_braun@kabelmail.de>
 Build-Depends:
- debhelper-compat (= 12),
- catch,
- juce-modules-source (>= 5.4.4~),
- libasound2,
+ debhelper-compat (= 13),
+ catch2,
+ cmake,
+ fst-dev,
+ juce-modules-source (>= 6.0.0~),
  libfltk1.3-dev,
  libcurl4-gnutls-dev | libcurl-dev,
  libjack-dev,
  libjansson-dev,
- libpulse-dev,
- librtmidi-dev (>= 2.1.0~ds0),
+ librtaudio-dev,
+ librtmidi-dev,
  libsamplerate0-dev,
  libsndfile1-dev,
  libxext-dev,
@@ -24,7 +26,7 @@
  nlohmann-json3-dev,
  xauth,
  xvfb,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/multimedia-team/giada.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/giada

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,13 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+# see ENVIRONMENT in dpkg-buildflags(1)
+export DEB_CPPFLAGS_MAINT_APPEND =
+export DEB_CXXFLAGS_MAINT_APPEND =
+export DEB_LDFLAGS_MAINT_APPEND =
+
+# workaround for an FST bug
+DEB_CPPFLAGS_MAINT_APPEND += -D_fstEffect=AEffect
 
 DATE_FMT = %Y-%m-%d
 ifdef SOURCE_DATE_EPOCH
@@ -12,9 +18,10 @@
 
 JUCE_VERSION := $(shell dpkg-query --show --showformat='$${source:Version}' juce-modules-source)
 
-CPPFLAGS+=-DBUILD_DATE='"$(BUILD_DATE)"'
-CXXFLAGS+=-std=c++14 -Wno-error
-LIBS=$(shell pkg-config --libs libjpeg libpng libcurl)
+DEB_CPPFLAGS_MAINT_APPEND += -DBUILD_DATE='"$(BUILD_DATE)"' -DTEST_RESOURCES_DIR='"tests/resources/"'
+DEB_CXXFLAGS_MAINT_APPEND += -std=c++17 -Wno-error -Wno-error=format-security
+LIBS=$(shell pkg-config --libs libjpeg libpng libcurl rtaudio)
+DEB_CXXFLAGS_MAINT_APPEND += $(shell pkg-config --cflags libjpeg libpng libcurl rtaudio)
 
 # JUCE (used by giada) uses some c++11 features requiring atomic_store_8 and
 # atomic_load_8, so we need to link with libatomic on
@@ -29,26 +36,34 @@
 	LIBS += -latomic
 endif
 
+DEB_LDFLAGS_MAINT_APPEND += $(LIBS)
+
 %:
 	dh $@
 
+execute_before_dh_auto_configure:
+	for d in $(notdir $(patsubst %/,%,$(wildcard debian/missing-sources/mcl-*/))); do \
+		mkdir -p src/deps/$$d/src/; \
+		cp debian/missing-sources/$$d/* src/deps/$$d/src/; \
+	done
+	cp -ra /usr/share/juce src/deps/
+	# patch around some bugs in FST
+	sed -e 's|\(.*t_fstTimeInfo.smpteFrameRate.*\)|};\ntypedef enum {\1|' -e 's|\(.*SmpteFilm35mm.*\)|\1 } VstSmpteFrameRate;\nenum {dummy_enum|' /usr/include/pluginterfaces/fst/fst.h > src/deps/juce/modules/juce_audio_processors/format_types/fst.h
+	sed -e 's|<pluginterfaces/fst/fst.h>|"fst.h"|' -i src/deps/juce/modules/juce_audio_processors/format_types/juce_VSTPluginFormat.cpp
 override_dh_auto_configure:
 	dh_auto_configure -- \
-		--enable-vst \
-		--enable-system-catch \
-		--target=linux \
-		LIBS="$(LIBS)"
+		-DWITH_VST2=ON \
+		$(empty)
 
-override_dh_auto_build:
-	cp -rav /usr/share/juce src/deps/
-	dh_auto_build
 override_dh_auto_test:
-	@echo home: $(HOME)
 	HOME=/tmp xvfb-run -a dh_auto_test -a || (grep . test-suite.log giada_test.log; false)
 
-override_dh_auto_clean:
-	dh_auto_clean
+execute_after_dh_clean:
 	test -e src/deps/rtaudio-mode/Makefile && make -C src/deps/rtaudio-mod/ distclean || true
+	for d in $(notdir $(patsubst %/,%,$(wildcard debian/missing-sources/mcl-*/))); do \
+		rm -rf src/deps/$$d; \
+	done
+	rm -rf src/deps/juce/
 
 override_dh_installchangelogs:
 	dh_installchangelogs ChangeLog
@@ -56,7 +71,3 @@
 override_dh_gencontrol:
 	dh_gencontrol -- \
                 -Vjuce:BuiltUsing="juce ( = $(JUCE_VERSION) )"
-
-## all the file-exclusion magic is handled by debian/copyright
-get-orig-source:
-	uscan  --download
